class IndexTransformDecimationInFrequency(object):
	"""docstring for IndexTransformDecimationInFrequency"""
	def __init__(self, N):
		super(IndexTransformDecimationInFrequency, self).__init__()
		self.N = N
		self.new_k = range(self.N)
		self.build_index_vector()
		print 'new_k = ', self.new_k
		
	def reverse_order(self, sequence):
		for i in (range(len(sequence)/2-1)):
			i = i+1
			a = sequence[ i ];
			b = sequence[ self.new_k[i] ]
			sequence[ i ] = b
			sequence[ self.new_k[i] ] = a

	def build_index_vector(self):
		if self.N == 8:
			for indice in range(self.N):
				b = '{:03b}'.format(indice)
				b = b[::-1]
				self.new_k[indice] = int(b, 2)
		else:
			print'error, value not supported by the index_transform function'

if __name__ == "__main__":
	indexTransformDecimationInFrequency = IndexTransformDecimationInFrequency(8)
	x = range(8)
	print 'x ', x
	indexTransformDecimationInFrequency.reverse_order(x)
	print 'x rearranged ', x
	y = x
	indexTransformDecimationInFrequency.reverse_order(y)
	print 'y ', y
